from psimp import in_100, hund_div
from lucas import LucasPrime, StrongLucasPrime
from millerrabin import MillerRabin
from sieve import sieval
from time import process_time


def BailliePSW(n):
    if n < 2:
        return False
    if in_100(n):
        return True
    if hund_div(n) != 0:
        return False
    if MillerRabin(n, 2):
        return False
    return StrongLucasPrime(n)


def BailliePSWWeak(n):
    if n < 2:
        return False
    if in_100(n):
        return True
    if hund_div(n) != 0:
        return False
    if MillerRabin(n, 2):
        return False
    return LucasPrime(n)
